#INCLUDE "../prgs/main.h"

DEFINE CLASS __DIAMP_PDM AS CUSTOM
   Name="__DIAMP_PDM"

   SeeCount=0
   PI=.NULL.
   XMLDom=.NULL.

   PROCEDURE ParseTextEx(lcText,laSection,laData)
      * lcText   - Source text
      *@laSection - Array of sections
      *@laData    - Array of section's data

      LOCAL lii,loXML,liy,loNodes,liz,loNode,loItem,loObj,loPDMs,luCatch,loPI,loPDM
      loPI=This.PI
      loPDMs=EVAL(loPI.PDMs)
      loPDM=EVAL(loPI.PDM)



      IF ISNULL(This.XMLDom)
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         This.XMLDom=CREATEOBJECT("Microsoft.XMLDOM")
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            This.XMLDom=.NULL.
            RETURN .F.
         ENDIF
         This.XMLDom.SetProperty("SelectionLanguage","XPath")
      ENDIF
      loXML=This.XMLDom

      IF !loXML.LoadXML("<root>"+lcText+"</root>")
         loPDMs.WriteToLogFile(STRTRAN(STRTRAN(STRTRAN(loPI.GetString(loPI.iXMLDataFailed),"%File%",loPI.Par.File),"%CPEM%",loPI.CPEM),"%ID%",LTRIM(STR(loPI.ID,11))),.T.)
         loPDMs.WriteToLogFile(LTRIM(STR(loXML.parseError.errorCode,11))+" "+loXML.parseError.Reason,.F.)
         RETURN .F.
      ENDIF

*!*	   Descr="descr"
*!*	   Params="parameters"
*!*	   RetVal="retval"
*!*	   Remarks="remarks"
*!*	   Example="example"
*!*	   SeeAlso="seealso"
*!*	   CopyRight="copyright"
*!*	   Syntax="syntax"
*!*	   Propval="values"
*!*	   Appliesto="appliesto"

      DIME laData(ALEN(laSection))
      STORE .NULL. TO laData
      FOR lii=1 TO ALEN(laSection)
          * Read section
          loNodes=loXML.documentElement.selectNodes('/root/'+laSection(lii))

          IF laSection(lii)=="descr" OR laSection(lii)=="retval" OR ;
             laSection(lii)=="remarks" OR laSection(lii)=="copyright" OR ;
             laSection(lii)=="example"
             
             laData(lii)=""
             FOR liy=0 TO loNodes.Length-1
                 laData(lii)=laData(lii)+This.ParseText(loNodes.Item(liy).Text)
             NEXT
             LOOP
          ENDIF

          IF laSection(lii)=="syntax"
             laData(lii)=""
             FOR liy=0 TO loNodes.Length-1
                 laData(lii)=laData(lii)+This.ParseText(This.PI.Setting.ExprS+loNodes.Item(liy).Text+This.PI.Setting.ExprE)
             NEXT
             LOOP
          ENDIF

          IF laSection(lii)=="parameters"
             laData(lii)=CREATEOBJECT("custom")

             FOR liy=0 TO loNodes.Length-1
                 loNode=loNodes.Item(liy)
                 FOR liz=0 TO loNode.childNodes.Length-1
                     loItem=loNode.childNodes.Item(liz)
                     
                     laData(lii).AddObject("_"+LTRIM(STR(liz,11)),"_DIAMP_param")
                     loObj=laData(lii).Controls(laData(lii).ControlCount)
                     
                     loObj.xname=loItem.GetAttribute("name")
                     loObj.byref=loItem.GetAttribute("byref")
                     loObj.type=loItem.GetAttribute("type")
                     loObj.direction=loItem.GetAttribute("direction")
                     loObj.optional=loItem.GetAttribute("optional")
                     loObj.caption=loItem.GetAttribute("caption")
                     loObj.description=This.ParseText(loItem.Text)
                 NEXT
             NEXT
             LOOP
          ENDIF


          IF laSection(lii)=="seealso"
             laData(lii)=CREATEOBJECT("custom")

             FOR liy=0 TO loNodes.Length-1
                 loNode=loNodes.Item(liy)
                 FOR liz=0 TO loNode.childNodes.Length-1
                     loItem=loNode.childNodes.Item(liz)
                     
                     laData(lii).AddObject("_"+LTRIM(STR(liz,11)),"_DIAP_see")
                     loObj=laData(lii).Controls(laData(lii).ControlCount)

                     loObj.metadata=loItem.Text
                     
*!*	                     loObj.file=loItem.GetAttribute("file")
*!*	                     loObj.xclass=loItem.GetAttribute("xclass")
*!*	                     loObj.pem=loItem.GetAttribute("pem")
*!*	                     loObj.caption=loItem.GetAttribute("caption")
                 NEXT
             NEXT
             LOOP
          ENDIF

          IF laSection(lii)=="appliesto"
             laData(lii)=CREATEOBJECT("custom")

             FOR liy=0 TO loNodes.Length-1
                 loNode=loNodes.Item(liy)
                 IF liy=0
                    laData(lii).Tag=loNode.GetAttribute("auto")
                 ENDIF
                 FOR liz=0 TO loNode.childNodes.Length-1
                     loItem=loNode.childNodes.Item(liz)
                     
                     laData(lii).AddObject("_"+LTRIM(STR(liz,11)),"_DIAP_see")
                     loObj=laData(lii).Controls(laData(lii).ControlCount)

                     loObj.metadata=loItem.Text
                     
*!*	                     loObj.file=loItem.GetAttribute("file")
*!*	                     loObj.xclass=loItem.GetAttribute("xclass")
*!*	                     loObj.pem=loItem.GetAttribute("pem")
*!*	                     loObj.caption=loItem.GetAttribute("caption")
                 NEXT
             NEXT
             LOOP
          ENDIF


          IF laSection(lii)=="values"
             laData(lii)=CREATEOBJECT("custom")

             FOR liy=0 TO loNodes.Length-1
                 loNode=loNodes.Item(liy)
                 FOR liz=0 TO loNode.childNodes.Length-1
                     loItem=loNode.childNodes.Item(liz)
                     
                     laData(lii).AddObject("_"+LTRIM(STR(liz,11)),"_DIAP_value")
                     loObj=laData(lii).Controls(laData(lii).ControlCount)
                     
                     loObj.xname=loItem.GetAttribute("name")
                     loObj.description=This.ParseText(loItem.Text)
                 NEXT
             NEXT
             LOOP
          ENDIF

      NEXT
      
   ENDPROC

   PROCEDURE ConvertSee2HTML(lcFile,lcSee,laOut)
      * lcFile - 
      * lcSee  - Meta data odkazu
      *@laOut  - Matice s odkazy
      
      LOCAL liy,liz,lcSOFile,lcSOCls,lcSOMP,llSingle,lcPom,loPDMs,loPDM,liXX007

      LOCAL ARRAY laSO(1)

      loPDMs=EVAL(This.PI.PDMs)
      loPDM=EVAL(This.PI.PDM)

      liy=AT(":",lcSee,IIF(LEFT(lcSee,2)=":\",3,2))
      liz=AT_Space(lcSee,liy)
      liz=IIF(liz>0,AT_NonSpace(lcSee,liz),0)
      lcTitle=RTRIM(SUBST(lcSee,liz))
      lcSee=RTRIM(LEFT(lcSee,liz-1))

      liy=AT(":",lcSee,IIF(SUBS(lcSee,2,2)=":\",2,1))
      liz=AT(":",lcSee,IIF(SUBS(lcSee,2,2)=":\",3,2))
            
      lcSOFile=LEFT(lcSee,liy-1)
      lcSOCls=SUBST(lcSee,liy+1,liz-liy-1)
      lcSOMP=SUBST(lcSee,liz+1)
             
      IF EMPTY(lcSOFile)
         * Soubor nen definovn
         liy=IIF(EMPTY(lcSOMP),;
                loPDMs.GetClassAnchors(@laSO,lcSOCls,"../../"),;
                loPDMs.GetMPAnchors(@laSO,lcSOCls,lcSOMP,"../../"))
                       
         llSingle=liy=1
         IF llSingle
            lcPom=laSO(1,1)
            liXX007=laSO(1,4)
         ENDIF
      ELSE
         lcSOFile=IIF(lcSOFile="\\" OR SUBS(lcSOFile,2,2)=":\",lcSOFile,FULLPATH(lcSOFile,lcFile))
         llSingle=.T.
         * Soubor je definovn
         lcPom=IIF(EMPTY(lcSOMP) AND EMPTY(lcSOCls),loPDMs.GetAnchor(lcSOFile,"../../"),;
                  IIF(EMPTY(lcSOMP),loPDMs.GetClassAnchor(lcSOFile,lcSOCls,"../../"),;
                  loPDMs.GetMPAnchor(lcSOFile,lcSOCls,lcSOMP,"../../",@liXX007)))
         liXX007=IIF(EMPTY(lcSOMP) AND EMPTY(lcSOCls),_PDM_FG_Any,;
                  IIF(EMPTY(lcSOMP),_PDM_FG_Class,liXX007))
      ENDIF
       
      IF llSingle
         DIME laOut(1,4)
         laOut(1,1)=lcTitle
         laOut(1,2)=lcPom
         laOut(1,4)=liXX007
      ELSE
         DIME laOut(liy,4)
         laOut(1,1)=lcTitle
         FOR liz=1 TO liy
             laOut(liz,2)=laSO(liz,1)
             laOut(liz,3)=IIF(!EMPTY(lcSOMP),lcSOMP+IIF(EMPTY(laSO(liz,3)),""," ("+laSO(liz,3)+")"),lcSOCls)
             laOut(liz,4)=laSO(liz,4)
         NEXT
      ENDIF
      RETURN .T.
   ENDPROC


   PROCEDURE ParseText(lcText,liLevel)
      * lcText    - Text
      LOCAL liEnd,liStartC,liStartE,liStartx,liCount,lcRet,loPDM,loPDMs,;
            lcCodeS,lcCodeE,lcxhtmlS,lcxhtmlE,lcExprS,lcExprE,;
            lixhtmlS,lixhtmlE,liCodeS,liCodeE,liExprS,liExprE,;
            liStart,liType,lcPom,lcSeeS,lcSeeE,liSeeS,liSeeE,liStartS,liEndS,loSetting,lcSee,;
            liy,lcRow,liCount,llExit,lix,lcMeta,lcData,;
            lcnoteS,lcnoteE,lcstopS,lcstopE,lcquestS,lcquestE,lcexclaS,lcexclaE,lcinfoS,lcinfoE,;
            linoteS,linoteE,listopS,listopE,liquestS,liquestE,liexclaS,liexclaE,liinfoS,liinfoE


      LOCAL ARRAY laRows(1)

      liLevel=IIF(TYPE("liLevel")="L",0,liLevel+1)
            
      loPDMs=EVAL(This.PI.PDMs)
      loPDM=EVAL(This.PI.PDM)
      loSetting=This.PI.Setting

      lcCodeS=loSetting.CodeS
      lcCodeE=loSetting.CodeE
      lcxhtmlS=loSetting.xhtmlS
      lcxhtmlE=loSetting.xhtmlE
      lcExprS=loSetting.ExprS
      lcExprE=loSetting.ExprE
      lcSeeS=loSetting.SeeS
      lcSeeE=loSetting.SeeE

      liCodeS=LEN(lcCodeS)
      liCodeE=LEN(lcCodeE)
      lixhtmlS=LEN(lcxhtmlS)
      lixhtmlE=LEN(lcxhtmlE)
      liExprS=LEN(lcExprS)
      liExprE=LEN(lcExprE)
      liSeeS=LEN(lcSeeS)
      liSeeE=LEN(lcSeeE)

      lcnoteS=loSetting.noteS
      lcnoteE=loSetting.noteE
      lcstopS=loSetting.stopS
      lcstopE=loSetting.stopE
      lcquestS=loSetting.questS
      lcquestE=loSetting.questE
      lcexclaS=loSetting.exclaS
      lcexclaE=loSetting.exclaE
      lcinfoS=loSetting.infoS
      lcinfoE=loSetting.infoE

      linoteS=LEN(lcnoteS)
      linoteE=LEN(lcnoteE)
      listopS=LEN(lcstopS)
      listopE=LEN(lcstopE)
      liquestS=LEN(lcquestS)
      liquestE=LEN(lcquestE)
      liexclaS=LEN(lcexclaS)
      liexclaE=LEN(lcexclaE)
      liinfoS=LEN(lcinfoS)
      liinfoE=LEN(lcinfoE)

      lcRet=""
      DO WHILE .T.
         liStartC=AT(lcCodeS,lcText)
         liStartE=AT(lcExprS,lcText)
         liStartx=IIF(liLevel>0,0,AT(lcxhtmlS,lcText))

         IF liStartC+liStartx+liStartE=0
            lcRet=lcRet+IIF(liLevel>0,LEFT(lcText,LEN(lcText)),STRTRAN(StrTranHTMLString(LEFT(lcText,LEN(lcText))),CRLF,"<br />"+CRLF))
            EXIT
         ENDIF

         liType=IIF(liStartC+liStartE=0,3,;
                 IIF(liStartC+liStartx=0,2,;
                  IIF(liStartE+liStartx=0,1,;
                   IIF(liStartC=0,IIF(liStartE<liStartx,2,3),;
                    IIF(liStartE=0,IIF(liStartC<liStartx,1,3),;
                     IIF(liStartx=0,IIF(liStartC<liStartE,1,2),;
                      IIF(liStartC<liStartE AND liStartC<liStartx,1,;
                        IIF(liStartE<liStartC AND liStartE<liStartx,2,3))))))))
                     

         liStart=IIF(liType=1,liStartC,IIF(liType=2,liStartE,liStartx))
         lcRet=lcRet+IIF(liLevel>0,LEFT(lcText,liStart-1),STRTRAN(StrTranHTMLString(LEFT(lcText,liStart-1)),CRLF,"<br />"+CRLF))
         
         lcText=SUBST(lcText,liStart+IIF(liType=1,liCodeS,IIF(liType=2,liExprS,lixhtmlS)))
         liEnd=AT(IIF(liType=1,lcCodeE,IIF(liType=2,lcExprE,lcxhtmlE)),lcText)
         liEnd=IIF(liEnd=0,LEN(lcText)+1,liEnd)
         lcPom=LEFT(lcText,liEnd-1)
         IF liType=1 && Code
            lcRet=loPDM.Code2xhtml(@lcPom)
         ELSE
            IF liType=2 && Epression
               lcRet=loPDM.Expr2xhtml(@lcPom)
            ELSE
               * Nejdve lokalizuj vechny  elementy <see> </see>
               * Vem jejich obsah a peve ho na HTML
               liStartS=AT(lcSeeS,lcPom)
               DO WHILE liStartS>0
                  This.SeeCount=This.SeeCount+1
                  liEndS=AT(lcSeeE,lcPom)
                  liEndS=IIF(liEndS=0,LEN(lcPom)+1,liEndS)

                  lcSee=SUBST(lcPom,liStartS+liSeeS,liEndS-(liStartS+liSeeS))
               
                  lcSee=This.PI.ConvertSee2HTML(This.PI.Par.File,lcSee,LTRIM(STR(This.SeeCount,11)),.T.)
                  lcPom=STUFF(lcPom,liStartS,liEndS+liSeeE-liStartS,lcSee)
                  liStartS=AT(lcSeeS,lcPom)
              ENDDO

               liStartS=AT(lcnoteS,lcPom)
               DO WHILE liStartS>0
                  liEndS=AT(lcnoteE,lcPom)
                  liEndS=IIF(liEndS=0,LEN(lcPom)+1,liEndS)

                  lcData=This.PI.ConvertNote2HTML(SUBST(lcPom,liStartS+linoteS,liEndS-(liStartS+linoteS)))
                  lcPom=STUFF(lcPom,liStartS,liEndS+linoteE-liStartS,lcData)
                  liStartS=AT(lcnoteS,lcPom)
               ENDDO

               liStartS=AT(lcstopS,lcPom)
               DO WHILE liStartS>0
                  liEndS=AT(lcstopE,lcPom)
                  liEndS=IIF(liEndS=0,LEN(lcPom)+1,liEndS)

                  lcData=This.PI.ConvertStop2HTML(SUBST(lcPom,liStartS+listopS,liEndS-(liStartS+listopS)))
                  lcPom=STUFF(lcPom,liStartS,liEndS+listopE-liStartS,lcData)
                  liStartS=AT(lcstopS,lcPom)
               ENDDO

               liStartS=AT(lcquestS,lcPom)
               DO WHILE liStartS>0
                  liEndS=AT(lcquestE,lcPom)
                  liEndS=IIF(liEndS=0,LEN(lcPom)+1,liEndS)

                  lcData=This.PI.ConvertQuest2HTML(SUBST(lcPom,liStartS+liquestS,liEndS-(liStartS+liquestS)))
                  lcPom=STUFF(lcPom,liStartS,liEndS+liquestE-liStartS,lcData)
                  liStartS=AT(lcquestS,lcPom)
               ENDDO

               liStartS=AT(lcexclaS,lcPom)
               DO WHILE liStartS>0
                  liEndS=AT(lcexclaE,lcPom)
                  liEndS=IIF(liEndS=0,LEN(lcPom)+1,liEndS)

                  lcData=This.PI.ConvertExcla2HTML(SUBST(lcPom,liStartS+liexclaS,liEndS-(liStartS+liexclaS)))
                  lcPom=STUFF(lcPom,liStartS,liEndS+liexclaE-liStartS,lcData)
                  liStartS=AT(lcexclaS,lcPom)
               ENDDO

               liStartS=AT(lcinfoS,lcPom)
               DO WHILE liStartS>0
                  liEndS=AT(lcinfoE,lcPom)
                  liEndS=IIF(liEndS=0,LEN(lcPom)+1,liEndS)

                  lcData=This.PI.ConvertInfo2HTML(SUBST(lcPom,liStartS+liinfoS,liEndS-(liStartS+liinfoS)))
                  lcPom=STUFF(lcPom,liStartS,liEndS+liinfoE-liStartS,lcData)
                  liStartS=AT(lcinfoS,lcPom)
               ENDDO

               lcRet=lcRet+IIF(liLevel>0,lcPom,This.ParseText(lcPom,liLevel))
            ENDIF
         ENDIF
         lcText=SUBST(lcText,liEnd+IIF(liType=1,liCodeE,IIF(liType=2,liExprE,lixhtmlE)))
      ENDDO
      RETURN lcRet
   ENDPROC


   PROCEDURE GetAllSee(lcFile,lcObjF,lcPEMF,lcText)
      * lcFile - Base file
      * lcObjF - Base class
      * lcPEMF - Base PEM
      * lcText - Source metadata

      
      LOCAL liCount,loPDM,loPDMs,lii,;
            lcSeeS,lcSeeE,liSeeS,liSeeE,liStartS,liEndS,loSetting,lcSee,;
            liCount,liy,liz,lcSOFile,lcSOCls,lcSOMP,liCount2

      LOCAL ARRAY laSO(1)
            
      loPDMs=EVAL(This.PI.PDMs)
      loPDM=EVAL(This.PI.PDM)
      loSetting=This.PI.Setting

      lcSeeS=loSetting.SeeS
      lcSeeE=loSetting.SeeE

      liSeeS=LEN(lcSeeS)
      liSeeE=LEN(lcSeeE)

      liCount=OCCURS(lcSeeS,lcText)

      FOR lii=1 TO m.liCount
          liStartS=AT(lcSeeS,m.lcText,m.lii)

          liEndS=AT(lcSeeE,m.lcText,m.lii)
          liEndS=IIF(liEndS=0,LEN(m.lcText)+1,liEndS)

          lcSee=SUBST(lcText,liStartS+liSeeS,liEndS-(liStartS+liSeeS))


          liy=AT(":",lcSee,IIF(LEFT(lcSee,2)=":\",3,2))
          liz=AT_Space(lcSee,liy)
          liz=IIF(liz>0,AT_NonSpace(lcSee,liz),0)
          lcSee=RTRIM(LEFT(lcSee,liz-1))

          liy=AT(":",lcSee,IIF(SUBS(lcSee,2,2)=":\",2,1))
          liz=AT(":",lcSee,IIF(SUBS(lcSee,2,2)=":\",3,2))
            
          lcSOFile=ALLT(LEFT(lcSee,liy-1))
          lcSOCls=ALLT(SUBST(lcSee,liy+1,liz-liy-1))
          lcSOMP=ALLT(SUBST(lcSee,liz+1))

          * nyn nati vechny anchory pro dan <see>
          * postupn je projdi a vytvo kov odkazy

          IF EMPTY(lcSOFile)
             * Soubor nen definovn
             IF EMPTY(lcSOMP)
                liCount2=loPDMs.GetClassAnchors(@laSO,lcSOCls,"../../")
             ELSE
                liCount2=loPDMs.GetMPAnchors(@laSO,lcSOCls,lcSOMP,"../../")
             ENDIF

             FOR liy=1 TO liCount2
                 lcSOFile=IIF(laSO(liy,2)="\\" OR SUBS(laSO(liy,2),2,2)=":\",laSO(liy,2),FULLPATH(laSO(liy,2),lcFile))
                 lcSOCls=laSO(liy,3)
                 =m.loPDMs.AddCAnchor(lcSOFile+CHR(0)+lcSOCls+CHR(0)+lcSOMP,m.lcFile+CHR(0)+m.lcObjF+CHR(0)+m.lcPEMF,_PDM_CA_BackReference)
             NEXT
          ELSE
              lcSOFile=IIF(lcSOFile="\\" OR SUBS(lcSOFile,2,2)=":\",lcSOFile,FULLPATH(lcSOFile,lcFile))
              =m.loPDMs.AddCAnchor(lcSOFile+CHR(0)+lcSOCls+CHR(0)+lcSOMP,m.lcFile+CHR(0)+m.lcObjF+CHR(0)+m.lcPEMF,_PDM_CA_BackReference)
          ENDIF
          
      NEXT
   ENDPROC

ENDDEFINE

***************************************************
DEFINE CLASS _DIAMP_param AS CUSTOM
   name="_DIAMP_param"

   xname=""
   byref=""
   type=""
   direction=""
   optional="1"
   caption=""
   description=""
ENDDEFINE

***************************************************
DEFINE CLASS _DIAP_value AS CUSTOM
   name="_DIAP_value"
   xname=""
   description=""
ENDDEFINE

***************************************************
DEFINE CLASS _DIAP_see AS CUSTOM
   name="_DIAP_see"
   
   metadata=""
   
   file=""
   xclass=""
   pem=""
   caption=""
ENDDEFINE
